;--------------------------------------.
;             "We're back"             |-.
; 512b intro by Flying/Digital Reality | |
;        Released at CAFe'2002         | |
;______________________________________| |
; |______________________________________;

COSTBL  EQU #7400
TCOS16  EQU #7500
T_PAL   EQU #7700   ; LEAVE SOME FREE SPACE FOR STACK
OUTBUF  EQU #8000
TPLASM  EQU #C000
T_CIRC  EQU TPLASM

PL_MV1  EQU #4101
PLDMV1  EQU #0403
PL_MV2  EQU #4909
PLDMV2  EQU #FAFC

SBPTR1  EQU #0000
SBP1FD  EQU #0BAF
SBP1D   EQU #0773
SBPTR2  EQU #5E00
SBP2FD  EQU #F239
SBP2D   EQU #F4C7

    ORG #7000

    DI
; BLACK BORDER AND PAPER SETTING IS DONE IN BASIC,
; I HAVE NO PLACE FOR THEM HERE :)
;    XOR A
;    OUT (254),A

; CLEAR MEMORY (SCREEN AND #7200-#FFFF)
;    LD HL,#7200
;    LD DE,#7201
;    LD BC,#CE00
;    LD (HL),L
;    LDIR
;    LD B,#1B
;    LD (HL),L
;    LDIR

    LD HL,#7200
    LD DE,#7201
    LD BC,#E500
    LD (HL),L
    LDIR

; AFTER THIS LDIR WE HAVE HL=#5700, IT IS EXACTLY WHAT WE NEED
; FILL SCREEN WITH GRID
;    LD H,#57        ; L NOW =0, SO DON'T SET IT AGAIN
    LD A,#AA
C_GRID
    DEC L
    LD (HL),A
    JR NZ,C_GRID
    CPL
    DEC H
    BIT 6,H
    JR NZ,C_GRID

; DECRUNCH CIRCLE TABLE
    LD SP,D_CIRC                ; WE'RE NOT SAVE SP, BECAUSE
                                ; WE WILL NEVER BACK :)
    LD D,T_CIRC/#100+#2F-1      ; -1 BECAUSE 2 #00 BYTES ARE
                                ;    REMOVED FROM D_CIRC
    EXX
    LD H,T_CIRC/#100+#10+1      ; +1 BECAUSE 2 #00 BYTES ARE
                                ;    REMOVED FROM D_CIRC
GC1
    LD D,H
    LD L,#10
    LD E,#2F
    EXX
    LD B,D
    LD C,#10
    LD E,#2F
    XOR A
    POP HL
GC2
    ADD HL,HL
    ADC A,0
    LD (DE),A
    LD (BC),A
    DEC E
    INC C
    EXX
    LD (HL),A
    LD (DE),A
    INC L
    DEC E
    EXX
    BIT 5,C
    JR Z,GC2
    DEC D
    EXX
    INC H
    BIT 5,H
    JR Z,GC1
    EXX
    ADD HL,SP           ; PALETTES ARE LOCATED RIGHT AFTER BUMP
                        ; TABLE AND WE GET PTR ON THEM IN SP
                        ; NOW AND HL IS ALWAYS =0 HERE,
                        ; SO WE CAN SAVE 2 BYTES
; DECRUNCH PALETTES
    LD SP,T_PAL+63      ; (32-1)*2+1=63
    LD B,32-1           ; LEADING AND TRAILING #00 BYTES
                        ; ARE ALREADY IN MEMORY
DP1
    LD E,(HL)
    LD D,E
    PUSH DE
    INC HL
    DJNZ DP1
    DEC SP              ; TO LEAVE 1 #00 BYTE IN PALETTE

; GENERATE COS-LIKE TABLE
; THIS ROUTINE IS (c) IVAN ROSCHIN
    LD HL,#FF01         ;127^2+#C000
    LD D,H
    LD E,L
    LD BC,COSTBL+#40
    PUSH BC

    EXX
    POP DE
    LD BC,COSTBL+#C0
    LD H,B
    LD L,C

GCOS1
    DEC E
    DEC L
    EXX

    LD A,L
    ADD A,A
    LD A,H
    ADC A,A

    INC E
    INC E
    ADD HL,DE
    INC E
    INC E
    ADD HL,DE

    LD (BC),A
    INC C
    EXX
    LD (HL),A
    CPL
    LD (DE),A
    LD (BC),A
    INC C
    JR NZ,GCOS1

; GENERATE COS-TABLE WITH
; BC,DE - COSTBL, HL - COSTBL+#80
    LD L,E
    INC D       ; TO POINT TO TCOS16
GCOS2
    LD A,(HL)
; THIS LOOP IS DEFINITELY SLOWER, BUT EATS 2 BYTES LESS MEMORY
    LD B,4
GCOS3
    SRA A
    DJNZ GCOS3
    LD (DE),A
    INC E
    INC L
    JR NZ,GCOS2

; GENERATE PLASMA TABLE
    LD H,D              ; D CONTAINS TCOS16/#100,
                        ; L IS ALREADY = 0
    LD D,E              ; E IS ALREADY=0, NOW WE HAVE DE=0.
                        ; IT WILL CONTAIN X AND Y
    LD B,TPLASM/#100
GPL1
    LD C,#80            ; #00-#3F - CIRCLES, #80-#BF - PLASMA
                        ; IT CAN WONDER, BUT IT SAVES US
                        ; ANOTHER LD C,#80 AFTER INNER LOOP
GPL2
; PASCAL SOURCE :)
; x:=_x*4;
; y:=_y*4;
; c:=cosinus[x+y] shr 4;
; c:=c+sinus[x+y] shr 4;
; x:=x*2;
; y:=y*2;
; c:=c+cosinus[x] shr 4;
; c:=c+sinus[y] shr 4;
    LD A,D              ; Y
    ADD A,E             ; X+Y
    LD L,A
    PUSH HL             ; COS(X+Y)
    ADD A,#40           ; X+Y+#40
    LD L,A
    PUSH HL             ; SIN(X+Y)
    SUB E               ; Y+#40
    ADD A,D             ; 2*Y+#40
    LD L,A
    PUSH HL             ; SIN(2*Y)
    LD A,E
    ADD A,A             ; X*2
    LD L,A
    LD A,(HL)           ; COS(2*X)
    POP HL
    ADD A,(HL)          ; COS(2*X)+SIN(2*Y)
    POP HL
    ADD A,(HL)          ; COS(2*X)+SIN(2*Y)+SIN(X+Y)
    POP HL
    ADD A,(HL)          ; COS(2*X)+SIN(2*Y)+SIN(X+Y)+COS(X+Y)
    LD (BC),A
    INC C
    LD A,E
    ADD A,4
    LD E,A
    JR NZ,GPL2
    INC B
    LD A,D
    ADD A,4
    LD D,A
    JR NZ,GPL1

; === MAIN LOOP ===
MAIN
    LD A,PLASMA&#FF
    LD C,E
    LD B,H              ; H = #75
    CALL EFF_CH
    LD C,#20            ; B = #77
    CALL EFFECT
    LD (PLZMV2+1),A     ; WE JUST NEED RANDOM VALUE
    LD A,#0F
    LD (PL_DIV),A
    LD A,#80
    LD (TPL_SH+1),A
    LD B,D              ; D = #5B
    CALL EFF2
    LD C,#20
LOOP1
    LD B,#08
    CALL EFFECT
    DEC C
    JR NZ,LOOP1
    LD B,L              ; L = #55
    CALL EFFECT
    LD A,SINBAR&#FF
    CALL EFF_CH
    LD HL,#1F3F
    LD (BARCLR+1),HL
    CALL EFFECT
    JR MAIN

EFF_CH
    LD (EFFADR+1),A
EFFECT
    LD A,C
    LD (COLORS+1),A
EFF2
    PUSH BC
EFFADR
    CALL PLASMA
    POP BC
    DJNZ EFF2
    LD B,H
    RET

; THIS ROUTINE IS PLACED HERE JUST TO MOVE PLASMA ROUTINE
; SOMEWHERE INTO #7100 TO MAKE IT HAVE SAME HIGH BYTE ADDRESS
; AS SINBAR PROCEDURE HAVE
GETPTR
    LD D,COSTBL/#100
    LD E,H
    CALL GPTR1
    OR TPLASM/#100
    LD H,A
    LD E,L
GPTR1
    LD A,(DE)
    ADD A,#80       ; 8*((64-32)/2)
    RRCA
    RRCA
    RRCA
    AND #1F
TPL_SH
    ADD A,#00
    RET

; --- PLASMA EFFECT ---
PLASMA
PLZMV1
    LD HL,PL_MV1
    LD DE,PLDMV1
    ADD HL,DE
    LD (PLZMV1+1),HL
    CALL GETPTR
    LD C,A
    LD B,H
PLZMV2
    LD HL,PL_MV2
    LD DE,PLDMV2
    ADD HL,DE
    LD (PLZMV2+1),HL
    CALL GETPTR
    LD L,A
    LD D,OUTBUF/#100+24-1
PLZ1
    LD E,#20            ; IT CAN WONDER, BUT IT SAVES US
                        ; ANOTHER LD E,#20 AFTER INNER LOOP
    PUSH HL
    PUSH BC
PLZ2
    LD A,(BC)
    INC C
    ADD A,(HL)
    INC L
PL_DIV
    NOP             ; WILL BE REPLACED WITH "RRCA" FOR PLASMA
    AND #1F
    DEC E
    LD (DE),A
    JR NZ,PLZ2
    DEC D
    POP BC
    INC B
    POP HL
    INC H
    BIT 7,D
    JR NZ,PLZ1

SHOW
    EI
    HALT
    LD H,T_PAL/#100
    LD DE,#5800
    LD B,OUTBUF/#100+24-1
SHOW1
    LD C,#1F            ; IT CAN WONDER, BUT IT SAVES US
                        ; ANOTHER LD C,#20 AFTER INNER LOOP
SHOW2
    LD A,(BC)
COLORS
    ADD A,#00
    LD L,A
    LDI
    BIT 7,C
    JR Z,SHOW2
    BIT 7,B
    JR NZ,SHOW1
    RET

; --- MOVING SINUS BARS EFFECT ---
SINBAR
; CLEAR OUTBUF
    LD D,OUTBUF/#100+24-1
SBAR1
    LD H,D
    LD E,#1F
    LD L,#20
SBAR2
    LDD
    BIT 7,E
    JR Z,SBAR2
    BIT 7,D
    JR NZ,SBAR1
; D NOW POINTS TO OUTBUF/#100-1
; DRAW FRAME IN OUBUF
SBARP1
    LD HL,SBPTR1
    LD BC,SBP1FD
    ADD HL,BC
    LD (SBARP1+1),HL
    EXX
SBARP2
    LD HL,SBPTR2
    LD DE,SBP2FD
    ADD HL,DE
    LD (SBARP2+1),HL
    LD B,24
SBAR3
    LD DE,SBP2D
    ADD HL,DE
    LD A,H
    EXX
    LD BC,SBP1D
    ADD HL,BC
    LD C,A
    LD B,TCOS16/#100
    LD A,(BC)
    LD E,A
    LD C,H
    LD A,(BC)
    ADD A,E
    SRA A
    ADD A,#10
    LD E,A
    EX DE,HL
    PUSH HL
BARCLR
    LD BC,#0F2F
SBAR4
    INC H           ; LOOK ABOVE AT NOTICE ABOUT D REGISTER
    LD A,L
    LD (HL),B
    INC L
    LD (HL),B
    INC L
    LD (HL),B
    INC L
    LD (HL),C
    INC L
    LD (HL),C
    INC L
    LD (HL),C
    LD L,A
    DEC C
    DJNZ SBAR4
    POP HL
    EX DE,HL
    INC D
    EXX
    DJNZ SBAR3
    JP SHOW

D_CIRC
; NORMALLY THERE MUST BE 2 #00 BYTES FIRST, BUT I REMOVE THEM
    DEFB #08,#00,#48,#00,#48,#01
    DEFB #A8,#02,#A8,#06,#A8,#0D,#64,#17
    DEFB #D4,#1E,#D4,#37,#74,#3F,#EC,#3F
    DEFB #FA,#7E,#F6,#7F,#FE,#7F,#FF,#7F
D_PAL
; 4 PALETTES IN REVERSED ORDER (BECAUSE OF DECRUNCHING ROUTINE)
; - BLUE
; - RED (REVERSED)
; - GREEN
; - BLUE (REVERSED)
    DEFB #01,#41,#09,#49,#4D,#6D,#6F,#7F
    DEFB #6F,#67,#65,#64,#24,#44,#04,#00
    DEFB #02,#42,#12,#16,#56,#76,#77,#7F
    DEFB #6F,#6D,#4D,#49,#09,#41,#01
